/* Channel establishment messages: */
{0x3C, "9.1.28a", "RR INITIALISATION REQUEST"},
{0x3B, "9.1.1", "ADDITIONAL ASSIGNMENT"},
{0x3F, "9.1.18", "IMMEDIATE ASSIGNMENT"},
{0x39, "9.1.19", "IMMEDIATE ASSIGNMENT EXTENDED"},
{0x3A, "9.1.20", "IMMEDIATE ASSIGNMENT REJECT"},
{0x48, "9.1.12f", "DTM ASSIGNMENT FAILURE"},
{0x49, "9.1.12h", "DTM REJECT"},
{0x4A, "9.1.12i", "DTM REQUEST"},
{0x4B, "9.1.21f", "PACKET ASSIGNMENT"},
/* Ciphering messages: */
{0x35, "9.1.9", "CIPHERING MODE COMMAND"},
{0x32, "9.1.10", "CIPHERING MODE COMPLETE"},
/* Configuration change messages: */
{0x30, "9.1.12b", "CONFIGURATION CHANGE COMMAND"},
{0x31, "9.1.12c", "CONFIGURATION CHANGE ACKNOWLEDGE"},
{0x33, "9.1.12d", "CONFIGURATION CHANGE REJECT"},
/* Handover messages: */
{0x2E, "9.1.2", "ASSIGNMENT COMMAND"},
{0x29, "9.1.3", "ASSIGNMENT COMPLETE"},
{0x2F, "9.1.4", "ASSIGNMENT FAILURE"},
{0x2B, "9.1.15", "HANDOVER COMMAND"},
{0x2C, "9.1.16", "HANDOVER COMPLETE"},
{0x28, "9.1.17", "HANDOVER FAILURE"},
{0x2D, "9.1.28", "PHYSICAL INFORMATION"},
{0x4C, "9.1.12e", "DTM ASSIGNMENT COMMAND"},
{0x08, "9.1.21e", "RR-CELL CHANGE ORDER"},
{0x23, "9.1.13a", "PDCH ASSIGNMENT COMMAND"},
/* Channel release messages: */
{0x0D, "9.1.7", "CHANNEL RELEASE"},
{0x0A, "9.1.26", "PARTIAL RELEASE"},
{0x0F, "9.1.27", "PARTIAL RELEASE COMPLETE"},
/* Paging and Notification messages: */
{0x21, "9.1.22", "PAGING REQUEST TYPE 1"},
{0x22, "9.1.23", "PAGING REQUEST TYPE 2"},
{0x24, "9.1.24", "PAGING REQUEST TYPE 3"},
{0x27, "9.1.25", "PAGING RESPONSE"},
{0x20, "9.1.21b", "NOTIFICATION/NCH"},
{0x25, "", "Reserved"},
{0x26, "9.1.21d", "NOTIFICATION RESPONSE"},
{0x0B, "", "Reserved"},
{0x4E, "9.1.21g", "PACKET NOTIFICATION"},
/* 3G Specific messages */
{0x60, "9.1.11a", "UTRAN CLASSMARK CHANGE"},
{0x62, "9.1.11b", "cdma2000 CLASSMARK CHANGE"},
{0x63, "9.1.15a", "INTER SYSTEM TO UTRAN HANDOVER COMMAND"},
{0x64, "9.1.15b", "INTER SYSTEM TO CDMA2000 HANDOVER COMMAND"},
/* System information messages: */
{0x18, "9.1.42", "SYSTEM INFORMATION TYPE 8"},
{0x19, "9.1.31", "SYSTEM INFORMATION TYPE 1"},
{0x1A, "9.1.32", "SYSTEM INFORMATION TYPE 2"},
{0x1B, "9.1.35", "SYSTEM INFORMATION TYPE 3"},
{0x1C, "9.1.36", "SYSTEM INFORMATION TYPE 4"},
{0x1D, "9.1.37", "SYSTEM INFORMATION TYPE 5"},
{0x1E, "9.1.40", "SYSTEM INFORMATION TYPE 6"},
{0x1F, "9.1.41", "SYSTEM INFORMATION TYPE 7"},
/* System information messages: */
{0x02, "9.1.33", "SYSTEM INFORMATION TYPE 2bis"},
{0x03, "9.1.34", "SYSTEM INFORMATION TYPE 2ter"},
{0x07, "9.1.34a", "SYSTEM INFORMATION TYPE 2quater"},
{0x05, "9.1.38", "SYSTEM INFORMATION TYPE 5bis"},
{0x06, "9.1.39", "SYSTEM INFORMATION TYPE 5ter"},
{0x04, "9.1.43", "SYSTEM INFORMATION TYPE 9"},
{0x00, "9.1.43a", "SYSTEM INFORMATION TYPE 13"},
/* System information messages: */
{0x3D, "9.1.43d", "SYSTEM INFORMATION TYPE 16"},
{0x3E, "9.1.43e", "SYSTEM INFORMATION TYPE 17"},
/* System information messages: */
{0x40, "9.1.43.g", "SYSTEM INFORMATION TYPE 18"},
{0x41, "9.1.43f", "SYSTEM INFORMATION TYPE 19"},
{0x42, "9.1.43.h", "SYSTEM INFORMATION TYPE 20"},
/* Miscellaneous messages: */
{0x10, "9.1.5", "CHANNEL MODE MODIFY"},
{0x12, "9.1.29", "RR STATUS"},
{0x17, "9.1.6", "CHANNEL MODE MODIFY ACKNOWLEDGE"},
{0x14, "9.1.13", "FREQUENCY REDEFINITION"},
{0x15, "9.1.21", "MEASUREMENT REPORT"},
{0x16, "9.1.11", "CLASSMARK CHANGE"},
{0x13, "9.1.12", "CLASSMARK ENQUIRY"},
{0x36, "9.1.52", "EXTENDED MEASUREMENT REPORT"},
{0x37, "9.1.51", "EXTENDED MEASUREMENT ORDER"},
{0x34, "9.1.13b", "GPRS SUSPENSION REQUEST"},
{0x4D, "9.1.12g", "DTM INFORMATION"},
{0x09, "9.1.49", "VGCS UPLINK GRANT"},
{0x0E, "9.1.48", "UPLINK RELEASE"},
{0x0C, "", "Reserved"},
{0x2A, "9.1.46", "UPLINK BUSY"},
{0x11, "9.1.44", "TALKER INDICATION"},
{0x38, "9.1.53", "APPLICATION INFORMATION"},
{-1, NULL, NULL}
/* Unused sections
  NOTIFICATION/FACCH [9.1.21a]
  HANDOVER ACCESS [9.1.14]
  SYNCHRONIZATION CHANNEL INFORMATION [9.1.30]
  UPLINK FREE [9.1.47]
  UPLINK ACCESS [9.1.45]
  ENHANCED MEASUREMENT REPORT [9.1.55]
  CHANNEL REQUEST [9.1.8]
  MEASUREMENT INFORMATION [9.1.54]
*/
